# (c) Foneticky ustav FF UK, Zuzana Ocelakova a Tomas Boril

library(stringr)
library(rPraat)

inputFolder <- "input"
outputFolder <- "output"

tierOfInterest <- "phrase"  # ktera vrstva se ma analyzovat


slovnik <- read.csv(file = "slabikovac_slovnik.txt", header = TRUE, sep = ",")
slovnik$slova <- as.character(slovnik$slova)

pocetSlabik <- function(vstup) {
    if (vstup == "") {
        return(0)
    } else {
        vstup <- tolower(vstup)
        vstup <- gsub("[^aeiouyáéěíóúůýmnbvcxlkjhgfdspztrwqčřžťďšň]", " ", vstup)
        vstup <- gsub("\\s+", " ", str_trim(vstup))
        vstup <- strsplit(x = vstup, split = " ", fixed = TRUE)
        vstup <- unlist(vstup)
        
        pocitadlo <- 0
        slova_s_diftongy <- character()
        sporna_slova <- character()
        uzite_pocty <- integer()
        pocetSlov <- length(vstup)
        pocetRadku <- nrow(slovnik)
        
        if (pocetSlov == 0) {
            return("")
        } else {
            
            for (k in (1:pocetSlov)) {
                
                slovo <- getElement(object = vstup, k)
                radek <- integer()
                
                for (j in (1:pocetRadku)) {
                    
                    polozka <- slovnik[j, "slova"]
                    
                    if ((grepl(slovo, polozka) == TRUE) & (grepl(polozka, slovo) == TRUE)) {
                        radek <- c(radek, j)
                    }
                }
                
                if (length(radek) != 0) {
                    
                    pocitadlo <- pocitadlo + slovnik[radek, 2]
                    
                    if (is.na(slovnik[radek, "pocet_slabik_2"]) == FALSE) {
                        sporna_slova <- c(sporna_slova, slovo)
                        uzite_pocty <- c(uzite_pocty, slovnik[radek, "pocet_slabik"])
                    }
                    
                } else {
                    
                    pocetZnaku <- nchar(slovo)
                    
                    for (i in (1:pocetZnaku)) {
                        
                        zn <- substr(slovo, i, i)
                        znPred <- ""
                        znPo <- ""
                        
                        if (i > 1) {
                            znPred <- substr(slovo, (i-1), (i-1))
                        }
                        if (i < pocetZnaku) {
                            znPo <- substr(slovo, (i+1), (i+1))
                        }
                        
                        if ((grepl("[aeiyouáéěíýóúů]", zn)) == TRUE) {
                            pocitadlo <- pocitadlo + 1
                        }
                        
                        if ((zn == "u") & (grepl("[aeo]", znPred) == TRUE)) {
                            pocitadlo <- pocitadlo - 1
                            slova_s_diftongy <- c(slova_s_diftongy, slovo)
                        }
                        
                        if (((grepl("[lr]", zn)) == TRUE) & ((grepl("[pbtdťďkgfvszšžcčhmnňlrřjxwq]", znPred) == TRUE)) & 
                            (grepl("[pbtdťďkgfvszšžcčhmnňlrřjxwq]", znPo) == TRUE)) {
                            pocitadlo <- pocitadlo + 1
                        } # SLABIKOTVORNÉ KONS UPROSTŘED SLOVA
                        # připočti 1, pokud znak je l/r a zároveň následující znak je souhláska a zároveň
                        # předchozí znak je buď souhláska, nebo nic
                        
                        if (((grepl("[lr]", zn)) == TRUE) & (grepl("[pbtdťďkgfvszšžcčhmnňlrřjxwq]", znPred) == TRUE) & 
                            (znPo == "")) {
                            pocitadlo <- pocitadlo + 1
                        } # SLABIKOTVORNÉ KONS NA KONCI SLOVA
                        # připočti 1, pokud znak je l/r a zároveň předchozí znak je souhláska a zároveň
                        # následující znak je nic
                        
                        if (((grepl("[lr]", zn)) == TRUE) & ((grepl("[pbtdťďkgfvszšžcčhmnňlrřjxwq]", znPred) == TRUE) |
                                                             (znPred == "")) &
                            (grepl("[lr]", znPo) == TRUE)) {
                            pocitadlo <- pocitadlo - 1
                        } # OŠETŘENÍ SKUPIN VÍCE SLABIKOTVORNÝCH KONS ("mrtvý" apod.)
                        # odečti 1, pokud znak je l/r a zároveň následující znak je l/r a zároveň 
                        # předchozí znak je buď souhláska, nebo nic
                        
                        
                        if (((zn == "m") & (znPred == "d") & (substr(slovo, (i-2), (i-2)) == "e") & 
                             (substr(slovo, (i-3), (i-3)) == "s")) & 
                            ((grepl("[nd]", znPo) == TRUE) | znPo == "" |
                             (znPo == "a" & 
                              (((substr(slovo, (i+2), (i+2)) == "d") & (substr(slovo, (i+3), (i+3)) == "v")) |
                               ((substr(slovo, (i+2), (i+2)) == "t") & (substr(slovo, (i+3), (i+3)) == "ř")) |
                               ((substr(slovo, (i+2), (i+2)) == "č") & (substr(slovo, (i+3), (i+3)) == "t")) |
                               ((substr(slovo, (i+2), (i+2)) == "p") & (substr(slovo, (i+3), (i+3)) == "a")) |
                               ((substr(slovo, (i+2), (i+2)) == "š") & (substr(slovo, (i+3), (i+3)) == "e")) |
                               ((substr(slovo, (i+2), (i+2)) == "s") & (substr(slovo, (i+3), (i+3)) == "e")) |
                               ((substr(slovo, (i+2), (i+2)) == "o") & (substr(slovo, (i+3), (i+3)) == "s")) |
                               ((substr(slovo, (i+2), (i+2)) == "d") & (substr(slovo, (i+3), (i+3)) == "e"))))))
                        {
                            pocitadlo <- pocitadlo + 1
                        } # ošetření slov obsahujících "SEDM"
                        
                        if (((zn == "m") & (znPred == "s") & (substr(slovo, (i-2), (i-2)) == "o")) & 
                            ((grepl("[nd]", znPo) == TRUE) | znPo == "" |
                             (znPo == "a" & 
                              (((substr(slovo, (i+2), (i+2)) == "d") & (substr(slovo, (i+3), (i+3)) == "v")) |
                               ((substr(slovo, (i+2), (i+2)) == "t") & (substr(slovo, (i+3), (i+3)) == "ř")) |
                               ((substr(slovo, (i+2), (i+2)) == "č") & (substr(slovo, (i+3), (i+3)) == "t")) |
                               ((substr(slovo, (i+2), (i+2)) == "p") & (substr(slovo, (i+3), (i+3)) == "a")) |
                               ((substr(slovo, (i+2), (i+2)) == "š") & (substr(slovo, (i+3), (i+3)) == "e")) |
                               ((substr(slovo, (i+2), (i+2)) == "s") & (substr(slovo, (i+3), (i+3)) == "e")) |
                               ((substr(slovo, (i+2), (i+2)) == "o") & (substr(slovo, (i+3), (i+3)) == "s")) |
                               ((substr(slovo, (i+2), (i+2)) == "d") & (substr(slovo, (i+3), (i+3)) == "e")))))) 
                        {
                            pocitadlo <- pocitadlo + 1
                        } # ošetření slov obsahujících "OSM"
                    }
                }
            }
            return(list(pocitadlo, slova_s_diftongy, sporna_slova))
        }
    }
}



listFiles <- list.files(path = inputFolder, pattern = "\\.TextGrid$" , ignore.case = TRUE)

for (I in seq_along(listFiles)) {
    file <- listFiles[I]
    fileName <- substr(file, 1, nchar(file) - nchar(".TextGrid"))
    fileTextGrid <- paste0(inputFolder, "/", fileName, ".TextGrid")
    fileTextGridOut <- paste0(outputFolder, "/", fileName, ".TextGrid")

    tg <- tg.read(fileTextGrid)
    tierSpocitat <- tg[[tierOfInterest]]  # ktera vrstva se ma analyzovat
    
    tg <- tg.insertNewIntervalTier(tg, newInd = Inf, newTierName = "nsyll")
    tg <- tg.insertNewIntervalTier(tg, newInd = Inf, newTierName = "ar")
    tg <- tg.insertNewIntervalTier(tg, newInd = Inf, newTierName = "notes")
    
    for (I in seqM(1, length(tierSpocitat$label))) {
        lab <- tierSpocitat$label[I]
        t1 <- tierSpocitat$t1[I]
        t2 <- tierSpocitat$t2[I]
        if (lab != "") {
            p <- pocetSlabik(lab)
            slabik <- p[[1]]
            notes <- ""
            if (length(p[[2]]) != 0) {
                notes <- paste0(notes, "Sekvence au/eu/ou počítané jako 1 slabika: ", p[[2]], collapse = ". ")
            }
            if (length(p[[3]]) != 0) {
                notes <- paste0(notes, " Sporné (započítané slabiky v závorce): ", p[[3]], collapse = ". ")
            }
            
            tg <- tg.insertInterval(tg, tierInd = "nsyll", tStart = t1, tEnd = t2, label = as.character(slabik))
            tg <- tg.insertInterval(tg, tierInd = "ar", tStart = t1, tEnd = t2, label = as.character(slabik / (t2 - t1)))
            tg <- tg.insertInterval(tg, tierInd = "notes", tStart = t1, tEnd = t2, label = notes)
        }
    }
    
    tg.write(tg, fileTextGridOut)
}

cat("Done.\n")
